/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2022/08/08
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
 ѯշģʽ̣
 MasterUSART1_Tx(PD5)USART1_Rx(PD6)
 ʾ USART1 յCH341͵ȡ 115200

 ע
     ӲߣPD5  Rx
           PD6  Tx

*/

#include "debug.h"


/* Global define */


/* Global Variable */
u32 buf[16];

/*********************************************************************
 * @fn      Flash_Test_Fast
 *
 * @brief   Flash Fast Program Test.
 *
 * @return  none
 */
void Flash_Test_Fast(void)
{
    u8  i, Verity_Flag = 0;

    for(i = 0; i < 16; i++){
        buf[i] = i;
    }

    FLASH_Unlock_Fast();

    FLASH_ErasePage_Fast(0x1FFFF800);

    printf("64Byte Page Erase Suc\r\n");

    FLASH_BufReset();
    for(i=0; i<16; i++){
        FLASH_BufLoad(0x1FFFF800+4*i, buf[i]);


    }

    FLASH_ProgramPage_Fast(0x1FFFF800);

    printf("64Byte Page Program Su\r\n");

    FLASH_Lock_Fast();

    for(i = 0; i < 16; i++){
        if(buf[i] == *(u32 *)(0x1FFFF800 + 4 * i))
        {
            printf("%x  ",buf[i]);
            Verity_Flag = 0;
        }
        else
        {
            Verity_Flag = 1;
            break;
        }
    }

    printf("\n");
    if(Verity_Flag)
        printf("64Byte Page Verity Fail\r\n");
    else
        printf("64Byte Page Verity Suc\r\n");
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n",SystemCoreClock);

    Flash_Test_Fast();
    while(1)
    {

    }
}
